Title Emulation Camp - Intro 2

Dosseg
.MODEL Small
.Stack 80h
.386
Locals

EXTRN _HSCPlayer:far    ; FM tune player

GfxSeg Segment Use16
;----- DIFFERENTS ANIMATIONS - ALSO CHECK ON LINE 76 FOR PALETTE ------------
include pic1.pic ; Bombjack
;include pic2.pic ; Pacman
;include pic3.pic ; Mario
;----------------------------------------------------------------------------
GfxSeg Ends

;
		.Data
;
msg             db '*PLEASE WAIT*$'
endmsg          db ''
                db 'Intro coded by Babyloon / Zen & Revelation',13,10
                db 13, 10
                db 'Emulation Camp', 13, 10
                db 'http://www.emucamp.com', 13, 10
                db 13, 10
                db 'Emulation World', 13, 10
                db 'http://www.emulationworld.com', 13, 10
                db '$'

FPUNotFoundStr  db 'FPU not found...$'
Info            db  ' EMULATION WORLD'
                db ''
                db ' BLABLA BLABLA BLABLA'
                db ' BLABLA BLABLA BLABLA'
                db ' BLABLA BLABLA BLABLA'
                db ''
                db ' HTTP_\\WWW;EMULATIONWORLD;COM'
                db ''
                db ''
                db ''
                db '                                     EMULATION CAMP'
                db '                                                   '
                db '                    EMULATORS < ROMS < TRANSLATIONS'
                db '                   DUELS < TRADING POSTS < CONTESTS'
                db '                   REVIEWS < INTERVIEWS < SAVEGAMES'
                db '                     CHEATS < MESSAGE BOARD < VOTES'
                db '                                                   '
                db '                             HTTP_\\WWW;EMUCAMP;COM$'

Info_Y           dw 6

;
		.Code
;

        Bufferseg       Dw 0
        StarsSeg        dw 0
        Randomseed      Dd 5fe6c809h
        BombJack        dw 0
        BJTEMP_         dd 0
        xc              dw 0  ; coordinates of the light source
        yc              dw 0
        Sine            label word
                        dw 256 dup (00h)
        Cosine          label word
                        dw 1024 dup (00h)

	Include     	Memory.Inc
        Include         zoop.Fnt

        ;----- PALETTE FOR DIFFERENTS VERSIONS ------------------------------
        Include         colors1.pal ; bombjack & pacman
        ; Include       colors2.pal ; mario
        ;--------------------------------------------------------------------

Tune Label Byte
        include         zoop.zik

;
; Start: the main() procedure..
;
Start		Proc Near
	Mov     Ax,@Data
    	Mov     Ds,Ax

	Call    InitAlloc

@@CheckFPU:
        xor     dx,dx
        mov     byte ptr cs:wait1,90h   ; NOP_CODE!
        mov     byte ptr cs:wait2,90h
wait1:  finit
        mov     byte ptr XC+1,0
wait2:  fstcw   XC
        cmp     byte ptr XC+1,3
        je      short @@FPUFound
        mov     ah,9
        mov     dx,offset FPUNotFoundStr
        int     21h
        jmp     @@EndFPUError
@@FPUFound:

	Mov     Bx,4096
    	Call    getrammem
        Mov     [Bufferseg],Ax ; alloc 64K for virtual screen
        Mov     Bx,4096
    	Call    getrammem
        Mov     [StarsSeg],Ax  ; alloc 64K for starfield
        mov     al,2
        out     21h,al
        mov     dx,offset msg
        mov     ah,9
        int     21h

        push    ds
        mov     XC,1024         ; number of angles
        Mov     YC,1000h        ; coef.
        finit
        xor     si, si
        mov     ax, cs
        mov     es, ax
        mov     ds, ax
        mov     cx, 1024+256    ; number of angles+(number of angles)/4
        fild    [YC]
        fldpi
        fild    [XC]
        fdivp   st(1), st
@@MakeSINCOS:
        mov     [XC], si
        fild    [XC]
        fmul    st, st(1)
        fsin
        fmul    st, st(2)
        fistp   word ptr [si+Sine]
        inc     si
        inc     si
        loop    @@MakeSINCOS
        pop     ds

@@CheckAdLib:
        mov     ah,4
        xor     bx,bx
        call    _HSCPlayer

        xor     ah,ah
        xor     bl,bl   ; use Old IRQ
        xor     bh,bh   ; No Polling
        push    cs
        pop     es
        mov     si,Offset Tune
        call    _HSCPlayer

@@InitStars_:
        mov     es,[StarsSeg]
        xor     di,di
        mov     cx,100
@@InitSLoop:
        call    random
        and     ax,63
        mov     es:[di],ax
        call    random
        and     ax,63
        mov     es:[di+2],ax
        call    random
        and     ax,3
        inc     ax
        mov     es:[di+4],ax
        add     di,6
        dec     cx
        jnz     @@InitSLoop

@@InitGraphic_:
        mov     es,[BufferSeg]
        xor     di,di
        mov     eax,01010101h
        mov     cx,16384
        rep     stosd

        mov     di,20*320
        mov     dx,70
        mov     eax,08080808h
@@YLoop11:
        mov     cx,120/4
        rep     stosd
        add     di,320-120
        dec     dx
        jnz     @@YLoop11

        mov     di,110*320+185
        mov     dx,90
        mov     eax,08080808h
@@YLoop12:
        mov     cx,84/4
        rep     stosd
        add     di,320-84
        dec     dx
        jnz     @@YLoop12

        mov     di,142*320+10
        mov     dx,48
        mov     eax,09090909h
@@YLoop13:
        mov     cx,48/4
        rep     stosd
        add     di,320-48
        dec     dx
        jnz     @@YLoop13

        mov     di,142*320+10
        mov     cx,48/4
        mov     eax,06060606h
        rep     stosd

        mov     di,(142+48)*320+10
        mov     cx,48/4
        mov     eax,06060606h
        rep     stosd

        mov     di,142*320+10
        mov     si,142*320+10+48
        mov     cx,49
        xor     bx,bx
        mov     al,06h
@@Yloop14:
        mov     es:[di+bx],al
        mov     es:[si+bx],al
        add     bx,320
        dec     cx
        jnz     @@Yloop14

        mov     di,5*320+230
        mov     dx,65
        mov     al,07h
@@YLoop15:
        mov     cx,66
        rep     stosb
        add     di,320-66
        dec     dx
        jnz     @@YLoop15

        mov     di,5*320+230
        mov     cx,65
        mov     al,02h
        rep     stosb

        mov     di,(5+65)*320+230
        mov     cx,65
        mov     al,02h
        rep     stosb

        mov     di,5*320+230
        mov     si,5*320+230+65
        mov     cx,66
        xor     bx,bx
        mov     al,02h
@@Yloop16:
        mov     es:[di+bx],al
        mov     es:[si+bx],al
        add     bx,320
        dec     cx
        jnz     @@Yloop16


        Mov     Ax,13h
	Int     10h		; Init MCGA 320x200 256 color mode

        Xor     Bx,Bx
        Mov     Cx,256
@@Inipalloop:
        Mov     Dx,03C8h
        Mov     Ax,256
        Sub     Ax,Cx
        Out     Dx,Al
        Inc     Dx
        Mov     Al,pal[Bx]
        Out     Dx,Al
        Mov     Al,pal[Bx+1]
        Out     Dx,Al
        Mov     Al,pal[Bx+2]
        Out     Dx,Al
        Add     Bx,3
        Dec     Cx
        Jnz     Short @@Inipalloop

        mov     fs,[Bufferseg]

@@MainLoop:                             ; boucle principale
        push    ds
        mov     si,[BombJack]
        shl     si,4
        mov     es,[BufferSeg]
        mov     di,158*320+27           ; coordonnes du bombjack
        mov     ax,GfxSeg
        mov     ds,ax
        mov     dx,16
@@YLoopBombJack:
        mov     cx,16/4
        rep     movsd
        add     di,320-16
        add     si,320-16

        dec     dx
        jnz     @@YLoopBombJack
        pop     ds

        push    ds
        mov     es,[BufferSeg]
        mov     ds,[StarsSeg]
        xor     si,si
        mov     cx,100
@@LoopStars:
        mov     di,ds:[si+2]
        add     di,6
        imul    di,320
        add     di,231
        mov     bx,ds:[si]
        mov     ax,ds:[si+4]
        mov     byte ptr es:[di+bx],0
        add     bx,ax
        and     bx,63
        add     al,9
        mov     es:[di+bx],al
        mov     ds:[si],bx
        add     si,6
        dec     cx
        jnz     @@LoopStars
        pop     ds

        mov     es,[BufferSeg]
        xor     ax,ax
        mov     bx,Info_Y
        Mov     Di,Offset Info
        Call    Writestring

        Mov     Dx,3DAh
@@Vbl1_cb2s:
    	In      Al,Dx
    	Test    Al,8
    	Jne     Short @@Vbl1_cb2s
@@Vbl2_cb2s:
    	In      Al,Dx
    	Test    Al,8
    	Je      Short @@Vbl2_cb2s   ; Wait for vbl.

    	Push    Ds
        Mov     Ds,Cs:BufferSeg
    	Xor     Si,Si
    	Mov     Ax,0A000h
    	Mov     Es,Ax
    	Xor     Di,Di
    	Mov     Cx,16000
    	Rep     Movsd               ; Copy the buffer to the screen.
    	Pop     ds

        inc     [BJTEMP_]
        and     [BJTEMP_],15        ; efface les quatres dernier bits
        cmp     [BJTEMP_],0
        jne     @@SkipBJ
        inc     [BombJack]          ; remet le compteur  zro
        and     [BombJack],3

@@SkipBJ:

        in      al,060h
        dec     al                      ; si echap est press
        Jnz     @@MainLoop              ; alors quitte la boucle

        mov     ah,2
        call    _HSCPlayer              ; stoppe la musique

        Mov     Bx,[Bufferseg]
    	Call    freerammem
        Mov     Bx,[StarsSeg]
        Call    freerammem
        xor     al,al
        out     21h,al

        Mov     Ax,03h                  ; retourne en mode texte
        Int     10h

@@EndFPUError:
        Mov     ah,9
        mov     dx,offset endmsg
        int     21h
        Mov     Ah,4Ch                  ; retourne au dos
        Int     21h
Start		Endp


;
; WriteChar: Write a char from CS:BP to ES:xx (size:6*11)
; In:
;    AX - X coord
;    BX - Y coord
;    CL - char number
;
Writechar       Proc Near
	Pusha
	Xor	Ch,Ch
	Sub	Cl,48
	Mov	Si,Cx
	Shl	Cx,2
	Add	Si,Si
	Add	Si,Cx	; si=cx*6

	Mov	Di,Bx
	Shl	Bx,8
	Shl	Di,6
	Add	Di,Bx
	Add	Di,Ax	; di=x+320*y
	Mov	Cx,10
@@Writecharloop:
	Mov	Ax,Cs:[Bp+Si]
        Or      Al,Al
        Je      Short @@@1
        Mov     byte ptr Es:[Di],3
@@@1:   Or      Ah,Ah
        Je      Short @@@2
        Mov     byte ptr Es:[Di+1],3
@@@2:
	Mov	Ax,Cs:[Bp+Si+2]
        Or      Al,Al
        Je      Short @@@3
        Mov     byte ptr Es:[Di+2],3
@@@3:   Or      Ah,Ah
        Je      Short @@@4
        Mov     byte ptr Es:[Di+3],3
@@@4:
	Mov	Ax,Cs:[Bp+Si+4]
        Or      Al,Al
        Je      Short @@@5
        Mov     byte ptr Es:[Di+4],3
@@@5:   Or      Ah,Ah
        Je      Short @@@6
        Mov     byte ptr Es:[Di+5],3
@@@6:
	Add	Si,320
	Add	Di,320
	Dec	Cx
	Jnz	Short @@Writecharloop
	Popa
	Ret
Writechar	Endp


;
; WriteString: Write a gfx string
; In:
;    DI - offset of string
;    AX - X coord
;    BX - Y coord
;
Writestring     Proc Near
	Pusha
        add     ax,5 ; decalage !
;        Mov     Es,Cs:BufferSeg
	Mov	Bp,Offset pic
@@Stringwriting:
	Mov	Cl,[Di]
	Cmp	Cl,32
	Je	Short @@Nowritechar
	Cmp	Cl,''
	Jne	Short @@Writeit
        mov     Ax,5 ; decalage !
	Add	Bx,11
	Jmp	Short	@@Nowritechar2
@@Writeit:
	Call	Writechar
@@Nowritechar:
	Add	Ax,6
@@Nowritechar2:
	Inc	Di
	Mov	Cl,[Di]
	Cmp	Cl,'$'
	Jne	Short @@Stringwriting
	Popa
	Ret
Writestring	Endp


Random          Proc
        pushad
        xor     eax,[RandomSeed]
        xor     eax,edx
        xchg    al,ah
        add     eax,0cd9c9a8fh
        xor     eax,esi
        add     eax,edi
        xor     eax,0526dafb2h
        add     eax,ecx
        xor     eax,ebx
        add     eax,ebp
        mov     [RandomSeed],eax
        in      al,64
        shl     eax,8
        in      al,65
        shl     eax,8
        in      al,64
        shl     eax,8
        in      al,64
        add     [randomseed],eax
        popad
        mov     eax,[randomseed]
        ret
Random          Endp

;
                End Start
;
